Qwt User's Guide: QwtPlotScaleItem Class Reference

Qwt User's Guide 5.2.3

- Main Page
- Related Pages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
QwtPlotScaleItem Class Reference

`#include <qwt_plot_scaleitem.h>`

Inheritance diagram for QwtPlotScaleItem:
[legend]

List of all members.

## Public Member Functions
| QwtPlotScaleItem (QwtScaleDraw::Alignment=QwtScaleDraw::BottomScale, const double pos=0.0)
virtual | ~QwtPlotScaleItem ()
int | borderDistance () const
virtual void | draw (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &rect) const
QFont | font () const
bool | isScaleDivFromAxis () const
QPalette | palette () const
double | position () const
virtual int | rtti () const
const QwtScaleDiv & | scaleDiv () const
const QwtScaleDraw * | scaleDraw () const
QwtScaleDraw * | scaleDraw ()
void | setAlignment (QwtScaleDraw::Alignment)
void | setBorderDistance (int numPixels)
void | setFont (const QFont &)
void | setPalette (const QPalette &)
void | setPosition (double pos)
void | setScaleDiv (const QwtScaleDiv &)
void | setScaleDivFromAxis (bool on)
void | setScaleDraw (QwtScaleDraw *)
virtual void | updateScaleDiv (const QwtScaleDiv &, const QwtScaleDiv &)
Public Member Functions inherited from QwtPlotItem
| QwtPlotItem (const QwtText &title=QwtText())
virtual | ~QwtPlotItem ()
void | attach (QwtPlot *plot)
virtual QwtDoubleRect | boundingRect () const
void | detach ()
void | hide ()
QwtDoubleRect | invTransform (const QwtScaleMap &, const QwtScaleMap &, const QRect &) const
bool | isVisible () const
virtual void | itemChanged ()
virtual QWidget * | legendItem () const
QRect | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
QwtPlot * | plot () const
QwtDoubleRect | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
void | setAxis (int xAxis, int yAxis)
void | setItemAttribute (ItemAttribute, bool on=true)
void | setRenderHint (RenderHint, bool on=true)
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
virtual void | setVisible (bool)
void | setXAxis (int axis)
void | setYAxis (int axis)
void | setZ (double z)
void | show ()
bool | testItemAttribute (ItemAttribute) const
bool | testRenderHint (RenderHint) const
const QwtText & | title () const
QRect | transform (const QwtScaleMap &, const QwtScaleMap &, const QwtDoubleRect &) const
virtual void | updateLegend (QwtLegend *) const
int | xAxis () const
int | yAxis () const
double | z () const
Public Member Functions inherited from QwtLegendItemManager
| QwtLegendItemManager ()
virtual | ~QwtLegendItemManager ()

## Additional Inherited Members
Public Types inherited from QwtPlotItem
enum | ItemAttribute { Legend = 1, AutoScale = 2 }
enum | RenderHint { RenderAntialiased = 1 }
enum | RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotUserItem = 1000 }

## Detailed Description

A class which draws a scale inside the plot canvas.

QwtPlotScaleItem can be used to draw an axis inside the plot canvas. It might by synchronized to one of the axis of the plot, but can also display its own ticks and labels.

It is allowed to synchronize the scale item with a disabled axis. In plots with vertical and horizontal scale items, it might be necessary to remove ticks at the intersections, by overloading updateScaleDiv().

The scale might be at a specific position (f.e 0.0) or it might be aligned to a canvas border.

Example
  The following example shows how to replace the left axis, by a scale item at the x position 0.0.

      QwtPlotScaleItem *scaleItem =
          new QwtPlotScaleItem(QwtScaleDraw::RightScale, 0.0);
      scaleItem->setFont(plot->axisWidget(QwtPlot::yLeft)->font());
      scaleItem->attach(plot);

      plot->enableAxis(QwtPlot::yLeft, false);

## Constructor & Destructor Documentation

QwtPlotScaleItem::QwtPlotScaleItem | ( | QwtScaleDraw::Alignment | alignment = `QwtScaleDraw::BottomScale`,
|  | const double | pos = `0.0`
| ) |  |
| explicit

Constructor for scale item at the position pos.

Parameters:

  alignment | In case of QwtScaleDraw::BottomScale/QwtScaleDraw::TopScale the scale item is corresponding to the xAxis(), otherwise it corresponds to the yAxis().
  pos | x or y position, depending on the corresponding axis.

See also:
  setPosition(), setAlignment()

## Member Function Documentation

int QwtPlotScaleItem::borderDistance | ( |  | ) | const

Returns:
  Distance from a canvas border

See also:
  setBorderDistance(), setPosition()

QFont QwtPlotScaleItem::font | ( |  | ) | const

Returns:
  tick label font

See also:
  setFont()

bool QwtPlotScaleItem::isScaleDivFromAxis | ( |  | ) | const

Returns:
  True, if the synchronization of the scale division with the corresponding axis is enabled.

See also:
  setScaleDiv(), setScaleDivFromAxis()

QPalette QwtPlotScaleItem::palette | ( |  | ) | const

Returns:
  palette

See also:
  setPalette()

double QwtPlotScaleItem::position | ( |  | ) | const

Returns:
  Position of the scale

See also:
  setPosition(), setAlignment()

int QwtPlotScaleItem::rtti | ( |  | ) | const
| virtual

Returns:
  QwtPlotItem::Rtti_PlotScale

Reimplemented from QwtPlotItem.

const QwtScaleDiv & QwtPlotScaleItem::scaleDiv | ( |  | ) | const

Returns:
  Scale division

const QwtScaleDraw * QwtPlotScaleItem::scaleDraw | ( |  | ) | const

Returns:
  Scale draw

See also:
  setScaleDraw()

QwtScaleDraw * QwtPlotScaleItem::scaleDraw | ( |  | ) |

Returns:
  Scale draw

See also:
  setScaleDraw()

void QwtPlotScaleItem::setAlignment | ( | QwtScaleDraw::Alignment | alignment | ) |

Change the alignment of the scale

The alignment sets the orientation of the scale and the position of the ticks:

- QwtScaleDraw::BottomScale: horizontal, ticks below
- QwtScaleDraw::TopScale: horizontal, ticks above
- QwtScaleDraw::LeftScale: vertical, ticks left
- QwtScaleDraw::RightScale: vertical, ticks right

For horizontal scales the position corresponds to QwtPlotItem::yAxis(), otherwise to QwtPlotItem::xAxis().

See also:
  scaleDraw(), QwtScaleDraw::alignment(), setPosition()

void QwtPlotScaleItem::setBorderDistance | ( | int | distance | ) |

Align the scale to the canvas.

If distance is >= 0 the scale will be aligned to a border of the contents rect of the canvas. If alignment() is QwtScaleDraw::LeftScale, the scale will be aligned to the right border, if it is QwtScaleDraw::TopScale it will be aligned to the bottom (and vice versa),

If distance is < 0 the scale will be at the position().

Parameters:

  distance | Number of pixels between the canvas border and the backbone of the scale.

See also:
  setPosition(), borderDistance()

void QwtPlotScaleItem::setFont | ( | const QFont & | font | ) |

Change the tick label font

See also:
  font()

void QwtPlotScaleItem::setPalette | ( | const QPalette & | palette | ) |

Set the palette

See also:
  QwtAbstractScaleDraw::draw(), palette()

void QwtPlotScaleItem::setPosition | ( | double | pos | ) |

Change the position of the scale

The position is interpreted as y value for horizontal axes and as x value for vertical axes.

The border distance is set to -1.

Parameters:

  pos | New position

See also:
  position(), setAlignment()

void QwtPlotScaleItem::setScaleDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign a scale division.

When assigning a scaleDiv the scale division won't be synchronized with the corresponding axis anymore.

Parameters:

  scaleDiv | Scale division

See also:
  scaleDiv(), setScaleDivFromAxis(), isScaleDivFromAxis()

void QwtPlotScaleItem::setScaleDivFromAxis | ( | bool | on | ) |

Enable/Disable the synchronization of the scale division with the corresponding axis.

Parameters:

  on | true/false

See also:
  isScaleDivFromAxis()

void QwtPlotScaleItem::setScaleDraw | ( | QwtScaleDraw * | scaleDraw | ) |

Set a scale draw.

Parameters:

  scaleDraw | object responsible for drawing scales.

The main use case for replacing the default QwtScaleDraw is to overload QwtAbstractScaleDraw::label, to replace or swallow tick labels.

See also:
  scaleDraw()

void QwtPlotScaleItem::updateScaleDiv | ( | const QwtScaleDiv & | xScaleDiv,
|  | const QwtScaleDiv & | yScaleDiv
| ) |  |
| virtual

Update the item to changes of the axes scale division.

In case of isScaleDivFromAxis(), the scale draw is synchronized to the correspond axis.

Parameters:

  xScaleDiv | Scale division of the x-axis
  yScaleDiv | Scale division of the y-axis

See also:
  QwtPlot::updateAxes()

Reimplemented from QwtPlotItem.